73ae0117a84c27e2d41f35f49b76521df8d56d85
[xfstests-dev.git] / 138
1 #! /bin/sh
2 #
3 #-----------------------------------------------------------------------
4 # Copyright (c) 2006 Silicon Graphics, Inc.  All Rights Reserved.
5 #
6 # This program is free software; you can redistribute it and/or
7 # modify it under the terms of the GNU General Public License as
8 # published by the Free Software Foundation.
9 #
10 # This program is distributed in the hope that it would be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program; if not, write the Free Software Foundation,
17 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
18 #
19 #-----------------------------------------------------------------------
20 #
21 # FSQA Test No. 138
22 #
23 # Test for NULL files problem
24 #
25 # creator
26 owner=lachlan@sgi.com
27
28 seq=`basename $0`
29 echo "QA output created by $seq"
30
31 here=`pwd`
32 tmp=/tmp/$$
33 status=1    # failure is the default!
34 trap "_cleanup; exit \$status" 0 1 2 3 15
35
36 _cleanup()
37 {
38     _cleanup_testdir
39 }
40
41 # get standard environment, filters and checks
42 . ./common.rc
43 . ./common.filter
44
45 # real QA test starts here
46 _supported_fs xfs
47 _supported_os Linux IRIX
48
49 _setup_testdir
50 _require_scratch
51 _scratch_mkfs_xfs >/dev/null 2>&1
52 _scratch_mount
53
54 # create files
55 i=1;
56 while [ $i -lt 1000 ]
57 do
58         file=$SCRATCH_MNT/$i
59         xfs_io -f -c "pwrite -b 64k -S 0xff 0 64k" $file > /dev/null
60         if [ $? -ne 0 ]
61         then
62                 echo error creating/writing file $file
63                 exit
64         fi
65         xfs_io -c "truncate 64k" $file > /dev/null
66         if [ $? -ne 0 ]
67         then
68                 echo error truncating file $file
69                 exit
70         fi
71         let i=$i+1
72 done
73
74 # give the system a chance to write something out
75 sleep 10
76
77 src/godown $SCRATCH_MNT
78
79 umount $SCRATCH_MNT
80 _scratch_mount
81 umount $SCRATCH_MNT
82 if [ ! _check_scratch_fs ]
83 then
84         echo error detected in filesystem
85         exit
86 fi
87 _scratch_mount
88
89 # check file size and contents
90 i=1;
91 while [ $i -lt 1000 ]
92 do
93         file=$SCRATCH_MNT/$i
94         # if file does not exist, the create was not logged, skip it
95         if [ -e $file ]
96         then
97                 # if file size is zero it cannot be corrupt, skip it
98                 if [ -s $file ]
99                 then
100                         # if file has non-zero size but no extents then it's contents will be NULLs, bad.
101                         if xfs_bmap $file | grep 'no extents' > /dev/null
102                         then
103                                 echo corrupt file $file - non-zero size but no extents
104                         elif xfs_bmap $file | grep 'hole' > /dev/null
105                         then
106                                 echo corrupt file $file - contains holes
107                         else
108                                 rm -f $file
109                         fi
110                 else
111                         rm -f $file
112                 fi
113         fi
114         let i=$i+1
115 done
116
117 status=0
118 exit